Bug 324721 - Left-handed mouse orientation also changes touchpad touch click
Left-handed mouse orientation also changes touchpad touch click
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: gnome-settings-daemon (Show other bugs)
10
All Linux
low Severity high
: ---
: ---
Assigned To: Ray Strode [halfline]
Fedora Extras Quality Assurance
http://bugs.freedesktop.org/show_bug....
:
: 442250 455492 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-10-09 07:44 EDT by David Campbell
Modified: 2009-05-07 23:43 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-29 18:04:19 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Pushed this untested patch (892 bytes, patch)
2008-12-10 12:47 EST, Ray Strode [halfline]
no flags Details | Diff

  None (edit)
Description David Campbell 2007-10-09 07:44:32 EDT
Description of problem:

If you change the mouse preferences to left handed, this SHOULD NOT change the
functionality of a tap on a laptop's touchpad, which should still function as
the primary mouse button click.

But on f7, switching to use a left-handed mouse changes the touchpad touch
functionality to be the reverse of what you'd expect.  This is annoying and
frustrating to left-handed users.

From dmesg:
input: PS/2 Mouse as /class/input/input1
input: AlpsPS/2 ALPS GlidePoint as /class/input/input2
input: AT Translated Set 2 keyboard as /class/input/input3

Versions:
Kernel 2.6.22.9-91.fc7
nautilus-2.18.3-1.fc7
Comment 1 Matěj Cepl 2007-10-10 19:08:41 EDT
Being a left-handed myself, I would ask just one question -- why do you use
left-handed mouse settings with touchpad? It doesn't make any sense to me. Do
you use both mouse and touchpad in the same time?
Comment 2 David Campbell 2007-10-10 19:28:31 EDT
I normally use an external mouse when my notebook is at home but if I decide to
use the touchpad or take the computer somewhere where I need to use it because I
don't have the mouse, then I shouldn't need to go into the settings to switch it
back to right handed....that becomes very annoying after 100 or so times of
using the notebook at home and then using it elsewhere, having to switch it.
Comment 3 Bug Zapper 2008-05-14 10:40:58 EDT
This message is a reminder that Fedora 7 is nearing the end of life. Approximately 30 (thirty) days from now Fedora will stop maintaining and issuing updates for Fedora 7. It is Fedora's policy to close all bug reports from releases that are no longer maintained. At that time this bug will be closed as WONTFIX if it remains open with a Fedora 'version' of '7'.

Package Maintainer: If you wish for this bug to remain open because you plan to fix it in a currently maintained version, simply change the 'version' to a later Fedora version prior to Fedora 7's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that we may not be able to fix it before Fedora 7 is end of life. If you would still like to see this bug fixed and are able to reproduce it against a later version of Fedora please change the 'version' of this bug. If you are unable to change the version, please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's lifetime, sometimes those efforts are overtaken by events. Often a more recent Fedora release includes newer upstream software that fixes bugs or makes them obsolete. If possible, it is recommended that you try the newest available Fedora distribution to see if your bug still exists.

Please read the Release Notes for the newest Fedora distribution to make sure it will meet your needs:
http://docs.fedoraproject.org/release-notes/

The process we are following is described here: http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Peter Hutterer 2008-07-15 01:35:49 EDT
This isn't really a mouse driver bug, it's a conceptual issue with the X
server's event processing.

Problem being that the SetPointerMapping request by default changes the core
pointer device. Up to X11R7.4, any core event, no matter who actually generates
it, comes from the core pointer and thus assumes the core pointer's mapping
(which in your case is left-handed).

This problem is fixed in Xorg git, but needs a vastly different input system. It
also requires configuration tools to set the button mapping per device, and not
just for the core pointer.
Comment 5 Peter Hutterer 2008-07-15 03:41:26 EDT
Did some more research, fix is possible for F9.

X.Org Bug 11683 [1] changed the mapping behaviour to take the device's button
mapping instead of the core pointer's. However, the core protocol request
SetPointerMapping applies to all devices, so a SetDeviceButtonMapping request is
required.

A button mapping per device is thus possible but requires an appropriate
configuration tool.

Changing component to control-center, this should be part of gnome-mouse-properties.

[1] http://bugs.freedesktop.org/show_bug.cgi?id=11683
Comment 6 Ray Strode [halfline] 2008-07-28 15:38:42 EDT
So at one point a long time ago gnome-settings-daemon just SetPointerMapping and
when users set their mouse to left handed mode only the first mouse would be
left handed and subsequent mice would be right handed.

(It got even weirder if you had /dev/mice as one device and /dev/input/mouse2
then you'd end up with the left and right mouse button getting pressed
simultaneously no matter which button you pressed)

I fixed that in gnome-settings-daemon by using SetDeviceButtonMapping on every
mouse device to be left handed.  I assume the code is still like that, but I
haven't looked at it in a while.

We don't need a configuration tool, we need to detect that the touch pad and not
remap it (assuming that's possible)
Comment 7 Matěj Cepl 2008-07-28 18:24:59 EDT
(In reply to comment #6)
> We don't need a configuration tool, we need to detect that the touch pad and
> not remap it (assuming that's possible)

Peter, what do you think?
Comment 8 Peter Hutterer 2008-07-28 21:13:03 EDT
SetDeviceButtonMapping is definitely the right way to go. In theory, a touchpad
should have the Atom XI_TOUCHPAD set as its type, although at least synaptics
doesn't do it.
so you need some other (human) method to figure out which device is a touchpad.
Comment 9 Ray Strode [halfline] 2008-07-29 09:44:26 EDT
we should fix synaptics, not punt to the user
Comment 10 Peter Hutterer 2008-08-10 21:48:50 EDT
*** Bug 442250 has been marked as a duplicate of this bug. ***
Comment 11 Peter Hutterer 2008-10-23 20:50:52 EDT
(In reply to comment #9)
> we should fix synaptics, not punt to the user

xorg-x11-drv-synaptics-0.15.2 announces itself as type XI_TOUCHPAD.
Comment 12 Frank Murphy 2008-11-15 06:15:58 EST
Any updates on this?
As my original https://bugzilla.redhat.com/show_bug.cgi?id=442250
is still there in the latest F-10\Rawhide,
and with F8 coming near eol :(

Frank
Comment 13 Frank Murphy 2008-12-07 07:17:30 EST
(In reply to comment #12)
> Any updates on this?
> As my original https://bugzilla.redhat.com/show_bug.cgi?id=442250
> is still there in the latest F-10\Rawhide,
> and with F8 coming near eol :(
> 
> Frank

This now seems to be sorted in F-10, is sporadic in F-9.
No longer have F8 insalled.

F10 -- xorg-x11-drv-synaptics-0.15.2-1.fc10.i386
F9 -- xorg-x11-drv-synaptics-0.15-3.fc9.i386


Frank
Comment 14 Matěj Cepl 2008-12-08 06:52:46 EST
Reporter, could you confirm, this has been fixed in F-10, please?

Thank you
Comment 15 David Campbell 2008-12-08 15:48:11 EST
No, I can see that this issue has NOT been resolved in F10 and is still apparent, at least with xorg-x11-drv-synaptics-0.15.2-1 which seems to be the latest released.

[root@clevo ~]# rpm -q -a | grep xorg-x11-drv-synaptics
xorg-x11-drv-synaptics-0.15.2-1.fc10.i386

[root@clevo ~]# uname -a
Linux clevo 2.6.27.5-117.fc10.i686 #1 SMP Tue Nov 18 12:19:59 EST 2008 i686 i686 i386 GNU/Linux

Changing the mouse orientation setting to left still incorrectly makes a tap on the touch pad bring up a pop-up menu.

input: PS/2 Mouse as /devices/platform/i8042/serio4/input/input5
input: AlpsPS/2 ALPS GlidePoint as /devices/platform/i8042/serio4/input/input6
Comment 16 Peter Hutterer 2008-12-09 18:42:41 EST
this is back to control-center now, it needs to avoid mapping buttons for devices that announce themselves as type XI_TOUCHPAD (see Comment #6)
Comment 17 Fedora Update System 2008-12-10 12:27:30 EST
gnome-settings-daemon-2.24.1-6.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/gnome-settings-daemon-2.24.1-6.fc10
Comment 18 Ray Strode [halfline] 2008-12-10 12:47:56 EST
Created attachment 326532 [details]
Pushed this untested patch

Would someone mind giving it a go?
Comment 19 Peter Hutterer 2008-12-10 17:45:31 EST
Sorry, still changes my touchpad (that's with 2.24.1-7)
Comment 20 Ray Strode [halfline] 2008-12-10 17:57:30 EST
Pushing another (again untested) build that may work.

We were calling XSetPointerMapping and the XInput equivalent.  Since XSetPointerMapping works on all devices now instead of just the core pointer, it was undoing the fix.

This change drops the XSetPointerMapping call.
Comment 21 Fedora Update System 2008-12-11 02:56:00 EST
gnome-settings-daemon-2.24.1-7.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update gnome-settings-daemon'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2008-11131
Comment 22 Ray Strode [halfline] 2008-12-12 10:17:19 EST
I spent some time testing this yesterday and it's not working.
Comment 23 Fedora Update System 2009-01-29 18:04:03 EST
gnome-settings-daemon-2.24.1-7.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 24 Mike C 2009-02-02 06:04:49 EST
Tested 2.24.1-7 on Samsung Q35 - switched mouse to left handed, and touchpad has also switched so that tap no longer gives normal options.  So this updated has not worked for this laptop.  This confirms comment #22 and a further attempt at fixing this problem is needed.
Comment 25 Mike C 2009-02-02 06:05:47 EST
Please re-open this bug as the problem is not fixed.
Comment 26 Matěj Cepl 2009-02-02 06:24:20 EST
(In reply to comment #25)
> Please re-open this bug as the problem is not fixed.

Please file a new bug, so that we have you as a reporter.

Thank you
Comment 28 Bastien Nocera 2009-05-07 23:43:20 EDT
*** Bug 455492 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.